/* File Announcer v.50 - By John Waters   */

if ~show(L,'rexxsupport.library') then
   call addlib('rexxsupport.library',0,-30,0)

parse arg uname','file .

signal on BREAK_C
signal on SYNTAX
signal on ERROR
Address Command

comment = statef(file)
area = word(comment,9)
name = translate(uname,' ','_')

tfiles = showdir('t:', 'f')
NumFiles = words(tfiles)

do i = 1 to NumFiles
   if right(word(tfiles,i),4) = 'user' then do
      call open(fp,'t:'word(tfiles,i),'r')
      PortUser = readch(fp,36)
      if pos(upper(Name), upper(PortUser)) ~= 0 then do
         Port = left(word(tfiles,i),3)
      end
      call close(fp)
   end
end

call open('tmp','t:'port'.body','r')
Desc = readch('tmp',700)
call close('tmp')

Description = translate(desc,' ','0d'x)
FileName = right(file,length(file)-lastpos('/',file))
FileSize = word(comment,2)

Line1 = overlay('Size: 'FileSize,'File: 'FileName,40)
Line2 = 'Desc: 'Description

if area = '-1' then do
   if ~exists('DLGConfig:Text/FileAnn.pri') then do
      'copy >NIL: DLGConfig:Text/FileAnn.pheader DLGConfig:Text/FileAnn.pri'
   end
   call open('tmp','DLGConfig:Text/FileAnn.Pri','a')
   toname = translate(word(comment,11),' ','_')
   line0 = overlay('To: 'toname,'From: 'upper(Name),40)
   call writeln('tmp',line0)
   call writeln('tmp',line1)
   call writeln('tmp',line2)
   call writeln('tmp',' ')
   call close('tmp')
end

else do  
   if ~exists('DLGConfig:Text/FileAnn.tmp') then do
      'copy >NIL: DLGConfig:Text/FileAnn.header DLGConfig:Text/FileAnn.tmp'
   end
   call open('tmp','DLGConfig:Text/FileAnn.tmp','a')
   call writeln('tmp',line1)
   call writeln('tmp',line2)
   call writeln('tmp',' ')
   call close('tmp')
end

exit

break_c:
ERROR:
SYNTAX:
  Say ''
  Say '*Hmmm, Looks like we got an Error in the File Announcer.*'
  Say '*Please tell the Sysop.*'
  Say '*Line:' SIGL '   Error Code:' RC'*'
  exit
